; Dallas 1-wire Ansteuerung von Peter Max, bei Fragen u. Verbesserungsvorschlgen,
; bitte eine email an sirpete@web.de
; Diese INCLUDE-Datei, steuert den 1-wire Bus von Dallas/MAXIM. 
; Dazu werden folgende Daten bentigt:

; DQ - Pin muss als Bit (Portpin) festgelegt werden.

; Die zu schreibenden Daten sowie die gelesenen Daten
; gelangen aus bzw. In den Accu

; Die ansteuerung eines Bauteils erfolgt immer nach dem selben Muster:
; 1. Initieren				CALL DS_Init
; 2. ROM-Command senden 		CALL DS_senden
; 3. Functions-Command senden		CALL DS_lesen

; Hier wird immer ein ganzes Byte Gesendet/gelesen, d.h. sendet Ihr die 64 Bit 
; ROM ID dann msste ihr den Behfel 8 mal mit dem jeweiligen Byte ausfhren.
; Beim Lesen verhllt es sich beim 64 Bit Code genau so, Acht mal hintereinander Lesen.
;
; Eine genauere Funktionsweise ist im Beispiel Programm fr den DS18B20 zu entnehmen.

; Ein Hauptproblem, bei der Entwicklung dieser Routine stelle die Tatsache dar,
; dass bei diesem Bus immer das niedrigst werige Bit gesendet wird.
; Wrde mich ebenfalls ber Postive sowie kritische Stellungnahmen,
; zu einen Routinen, freuen. (Nur so kann ich weiter Lernen.)

DS_Init:			'Bus Initieren
 CLR DQ			'Ist kein Bauteil vorhanden wird das Carry gesetzt.
 CALL wait_500		'Bauteil(e) Rest / "Suchen"
 SETB DQ
 CALL wait_15		
 CALL wait_15		'Warten bis Bauteil mit sicherheit antworten sollte.
 CALL wait_15
 CALL wait_15
 MOV C,DQ
 CALL wait_500		'Pause nach Reset (Nach Set > 500uS Pause)
RET

DS_senden:             	'Daten sind im AKKU'
  PUSH B               	'Rette Inhalt von B auf den Stack.'
  MOV B,#8             	'
DS8_Bits:              	'
  RRC A                	'Schiebe den Akkuinhalt nach rechts durch das Carry
  CLR DQ               	'um ihn Bitweise an den Bus zu legen. (0=1uS, 1=60-120uS)
  IF BIT C THEN SETB DQ	'Wird eine 0 geschrieben bleibt die Leitung auf LOW
  CALL wait_15         	'falls eine 1 geschrieben wird, muss man die Leitung
  CALL wait_15		'rechtzeitig wieder auf High legen, damit die als ! erkannt wird.
  CALL wait_15
  CALL wait_15
  SETB DQ
 DJNZ B,DS8_Bits
  RRC A
  POP B			'Stelle B wieder her (vom Stack holen)'
RET

DS_lesen:			'Liest ein Byte auf dem 1-Wire-Bus
  PUSH B
  MOV B,#8
DS8_Bit_l:
  RRC A
  CLR DQ
  NOP
  SETB DQ
  CALL wait_15
  MOV C,DQ
  CALL wait_15
  CALL wait_15
  CALL wait_15
 DJNZ B,DS8_Bit_l
  RRC A
  POP B         	     'siehe oben'
RET


  
  