

' wait.inc  -  Eine Sammlung von gngigen Abwarteroutinen.

' Die Zahlenangaben sind als Maschinentakte zu deuten, die Abwartezeit
' hngt also wesentlich von der Oszillatorfrequenz ab. Bei den gngigen
' MCS-51 Mikrocontrollern betrgt die Maschinentaktfrequenz ein
' zwlftel der Oszillatorfrequenz.
' Die Abwarteroutinen warten die angegebene Anzahl von Maschinen-
' takten ab. Bei einer 12 MHz Oszillatorfrequenz und Teilung durch 12
' entspricht die Angabe einer uS, bei 24 Mhz einer halben uS, u.s.w.

' list of wait routines:
'    wait_15		'15uS@12MHz / 7.5uS@24MHz
'    wait_50		'50uS@12MHz / 25uS@24MHz
'    wait_100		'100uS@12MHz / 50uS@24MHz
'    wait_200		'200uS@12MHz / 100uS@24MHz
'    wait_500		'0,5mS@12MHz / 250uS@24MHz
'    wait_1000		'1mS@12MHz / 500uS@24MHz
'    wait_2000		'2mS@12MHz / 1mS@24MHz
'    wait_5000		'5mS@12MHz / 2.5mS@24MHz
'    wait_10000		'10mS@12MHz / 5mS@24MHz
'    wait_20000		'20mS@12MHz / 10mS@24MHz
'    wait_50000		'50mS@12MHz / 25mS@24MHz
'    wait_100000		'100mS@12MHz / 50mS@24MHz
'    wait_1000000		'1000mS@12MHz / 500mS@24MHz
'    wait_5000000		'5000mS@12MHz / 2500mS@24MHz

' ------------------------------------------------------------------------------------------------

' destroys: 	R7
' time:		15 cyc.	(incl. LCALL/RET)
' stack:	2	      (incl. LCALL/RET)
wait_15:			NOP
				NOP
				MOV R7,#4			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				RET				'Rcksprung				

' --------------------------------------------------------------------------------------

' destroys: 	R7
' time:		100 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_50:			NOP
				MOV R7,#22			'R7 = 22
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				RET				'Rcksprung				

' --------------------------------------------------------------------------------------

' destroys: 	R7
' time:		100 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_100:			NOP
				mov R7,#47			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				RET				'Rcksprung				

' ------------------------------------------------------------------------------------------------

' destroys: 	R7
' time:		200 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_200:			nop
				mov R7,#97			'R7 = 97
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				ret				'Rcksprung				

' ------------------------------------------------------------------------------------------------

' destroys: 	R7
' time:		500 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_500:			NOP
				nop
				nop
				mov R7,#245			'R7 = 245
				nop
				nop
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				ret				'Rcksprung				

' ----------------------------------------------------------------------------

' destroys: 	R7
' time:		1000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_1000:			nop
				nop
				nop
				mov R7,#248			'R7 = 248
		_wait_s0:       nop
				nop
				DJNZ R7,_wait_s0		'R7--: If (R7 > 0) _wait_s0
				ret				'Rcksprung				

' ------------------------------------------------------------------------------------------------

' destroys: 	R6, R7
' time:		2000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_2000:			nop
				nop
				nop
				nop				
				mov R6,#181			'R6 = 181
		_wait_s1:	MOV R7,#4			'R7 = 4
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s1		'R6--: If (R6 > 0) _wait_s1
				ret				'Rcksprung				

' ------------------------------------------------------------------------------------------------

' destroys: 	R6, R7
' time:		5000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_5000:			#IF NOT DEBUGGING
				MOV R6,#37			'R6 = 37
		_wait_s2:	MOV R7,#67			'R7 = 67
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s2		'R6--: If (R6 > 0) _wait_s2
				#END IF
				ret				'Rcksprung

' ------------------------------------------------------------------------------------------------

' destroys: 	R6, R7
' time:		10000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_10000:			#IF NOT DEBUGGING
				NOP
				nop
				nop
				nop
				mov R6,#103			'R6 = 103
		_wait_s3:	MOV R7,#47			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s3		'R6--: If (R6 > 0) _wait_s3
				#END IF
				ret				'Rcksprung

' ------------------------------------------------------------------------------------------------

' destroys: 	R6, R7
' time:		20000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_20000:			#IF NOT DEBUGGING
				MOV R6,#215			'R6 = 215
		_wait_s4:	MOV R7,#45			'R7 = 45
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s4		'R6--: If (R6 > 0) _wait_s4
				#END IF
				ret				'Rcksprung

' ------------------------------------------------------------------------------------------------

' destroys: 	R6, R7
' time:		50000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_50000:			#IF NOT DEBUGGING
				MOV R6,#121			'R6 = 121
		_wait_s5:	MOV R7,#206			'R7 = 206
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s5		'R6--: If (R6 > 0) _wait_s5
				MOV R7,#10			'R7 = 10
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				NOP
				#END IF
				ret				'Rcksprung

' ------------------------------------------------------------------------------------------------
' destroys: 	R6, R7
' time:		100000 cyc.	(incl. LCALL/RET)
' stack:	2		(incl. LCALL/RET)
wait_100000:		#IF NOT DEBUGGING
				MOV R6,#236			'R6 = 236
		_wait_s6:	MOV R7,#210			'R7 = 210
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s6		'R6--: If (R6 > 0) _wait_s6	
				MOV R7,#83			'R7 = 83
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				#END IF
				ret				'Rcksprung

' ------------------------------------------------------------------------------------------------
' destroys: 	R5, R6, R7
' time:		500000 cyc.(incl. LCALL/RET)
' stack:		2		(incl. LCALL/RET)
wait_500000:
				#IF NOT DEBUGGING
				MOV R5,#25
		_wait_s7:	MOV R6,#215			'R6 = 215
		_wait_s8:	MOV R7,#45			'R7 = 45
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s8		'R6--: If (R6 > 0) _wait_s8
				DJNZ R5,_wait_s7		'R5--: If (R5 > 0) _wait_s7
				MOV R7,#47			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				#END IF
				RET				'Rcksprung

' ------------------------------------------------------------------------------------------------
' destroys: 	R5, R6, R7
' time:		1000000 cyc.(incl. LCALL/RET)
' stack:		2		(incl. LCALL/RET)
wait_1000000:
				#IF NOT DEBUGGING
				MOV R5,#50
		_wait_s9:	MOV R6,#215			'R6 = 215
		_wait_s10:	MOV R7,#45			'R7 = 45
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s10		'R6--: If (R6 > 0) _wait_s10
				DJNZ R5,_wait_s9		'R5--: If (R5 > 0) _wait_s9
				MOV R7,#47			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				#END IF
				RET				'Rcksprung

' ------------------------------------------------------------------------------------------------
' destroys: 	R5, R6, R7
' time:		5000000 cyc.(incl. LCALL/RET)
' stack:		2		(incl. LCALL/RET)
wait_5000000:
				#IF NOT DEBUGGING
				MOV R5,#250
		_wait_s11:	MOV R6,#215			'R6 = 215
		_wait_s12:	MOV R7,#45			'R7 = 45
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				DJNZ R6,_wait_s12		'R6--: If (R6 > 0) _wait_s10
				DJNZ R5,_wait_s11		'R5--: If (R5 > 0) _wait_s9
				MOV R7,#47			'R7 = 47
				DJNZ R7,$			'R7--: If (R7 > 0) repeat
				#END IF
				RET				'Rcksprung